local M = {}

local blackhole = {["expandAccDisc"] = true, ["scale"] = 0, ["rotation"] = 0}
local reset = false
local start = false
local windX = 0
local windY = 0
local windZ = 0
local timer3 = 0

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		reset = true
		start = false
		timer3 = 0
		blackhole = {["expandAccDisc"] = true, ["scale"] = 0, ["rotation"] = 0}
	end
end

local function onRaceStart()
	if not start then start = true end
end

local function updateBlackhole()
	if blackhole["expandAccDisc"] then
		blackhole["scale"] = blackhole["scale"]+0.1/2
		TorqueScript.eval([[
			accretionDisc.scale = "]]..blackhole["scale"]..[[ ]]..blackhole["scale"]..[[ ]]..blackhole["scale"]..[[";
		]])
		if blackhole["scale"] >= 5 then
			blackhole["expandAccDisc"] = false
		end
	end
	
	blackhole["rotation"] = blackhole["rotation"]+3
	TorqueScript.eval([[
		accretionDisc.rotation = "0 -1 0 ]]..blackhole["rotation"]..[[";
	]])
end

local function onPreRender(dt)
	if start then
		updateBlackhole()
	end
	
	if reset then
		TorqueScript.eval([[
			accretionDisc.scale = "0 0 0";
		]])
		reset = false
	end
end

local function onRaceTick(raceTickTime)
	timer3 = timer3+raceTickTime
	if timer3 % 1 == 0 and blackhole["scale"] > 1 and not death then
		local playerObject = scenetree.findObject('scenario_player0')
		local blackholeObject = scenetree.findObject('scenario_player1')
		local player = map.objects[map.objectNames['scenario_player0']]
		local blackhole = map.objects[map.objectNames['scenario_player1']]
		local distance = math.floor(math.abs((player.pos-blackhole.pos):length()))
		
		if playerObject:getPosition().x > blackholeObject:getPosition().x then 
			windX = -(750-distance)
		elseif playerObject:getPosition().x < blackholeObject:getPosition().x then 
		    windX = (750-distance)
		end
		
		if playerObject:getPosition().y > blackholeObject:getPosition().y then 
		    windY = -(750-distance)
		elseif playerObject:getPosition().y < blackholeObject:getPosition().y then 
		    windY = (750-distance)
		end
		
		if playerObject:getPosition().z > blackholeObject:getPosition().z then 
			windZ = -(750-distance)
		elseif playerObject:getPosition().z < blackholeObject:getPosition().z then 
			windZ = (750-distance)
		end
	
		local windLuaCommand = 'obj:setWind('..windX..','..windY..','..windZ..')'
		playerObject:queueLuaCommand(windLuaCommand)
	end
end

M.onPreRender = onPreRender
M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
return M